"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var attr_class_1 = require("../../commons/extends/attr.class");
var MenuPushComponent = /** @class */ (function (_super) {
    __extends(MenuPushComponent, _super);
    function MenuPushComponent() {
        var _this = _super.call(this) || this;
        _this.itemClick = new core_1.EventEmitter();
        _this.items = new Array();
        _this.max = 5;
        return _this;
    }
    MenuPushComponent.prototype.ngDoCheck = function () {
        this._items = Array.from(new Set(this.items));
        if (this._items.length > this.max) {
            this.items.shift();
        }
    };
    MenuPushComponent.prototype.goItem = function (item) {
        this.itemClick.emit(item);
    };
    MenuPushComponent.prototype.removeItem = function (index) {
        this.items.splice(index, 1);
    };
    MenuPushComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "ts-menu-push",
                    exportAs: 'tsMenuPush',
                    template: "<h3>\n        <button (click)=\"goItem(item)\"\n             *ngFor=\"let item of _items;index as i\" class=\"{{btnClass}} btn-sm badge-pill ml-1\" [class.active]=\"item.active\">\n            <span>{{item.title}}</span>\n            <!--<span (click)=\"removeItem(i)\">x</span>-->\n        </button>\n    </h3>",
                    styles: [
                        "",
                    ]
                },] },
    ];
    /** @nocollapse */
    MenuPushComponent.ctorParameters = function () { return []; };
    MenuPushComponent.propDecorators = {
        "items": [{ type: core_1.Input },],
        "max": [{ type: core_1.Input },],
        "itemClick": [{ type: core_1.Output },],
    };
    return MenuPushComponent;
}(attr_class_1.DomAttr));
exports.MenuPushComponent = MenuPushComponent;
//# sourceMappingURL=menu-push.component.js.map