"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var attr_class_1 = require("../../commons/extends/attr.class");
var MenuComponent = /** @class */ (function (_super) {
    __extends(MenuComponent, _super);
    function MenuComponent() {
        var _this = _super.call(this) || this;
        _this.menuActiveChange = new core_1.EventEmitter();
        _this.items = new Array();
        return _this;
    }
    Object.defineProperty(MenuComponent.prototype, "activeMainClass", {
        get: function () {
            return this.borderClass + " bg-" + this.color + "-fill";
        },
        enumerable: true,
        configurable: true
    });
    MenuComponent.prototype.toggleGroup = function (group) {
        var tempActive = group.active;
        this.setAllInActive();
        group.active = !tempActive;
    };
    MenuComponent.prototype.toggleMenu = function (group, itemIndex) {
        this.setAllInActive();
        group.active = true;
        group.menuItems[itemIndex].active = true;
        this.menuActiveChange.emit(group.menuItems[itemIndex]);
    };
    MenuComponent.prototype.setActive = function (menu) {
        this.setAllInActive();
        menu.active = true;
        menu.targetGroup.active = true;
    };
    MenuComponent.prototype.setAllInActive = function () {
        this.items.forEach(function (item) {
            item.menuGroups.forEach(function (a) {
                a.active = false;
                a.menuItems.forEach(function (b) {
                    b.active = false;
                });
            });
        });
    };
    MenuComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: "ts-menu",
                    exportAs: 'tsMenu',
                    template: "\n    <div class=\"h-100 pt-2\">\n        <div class=\"media pl-3 mb-3 pt-3\" *ngIf=\"avatars\">\n            <img class=\"mr-2 rounded-circle\" [src]=\"avatars[0]\" height=\"40\" width=\"40\" alt=\"Avatar \">\n            <div class=\"media-body\">\n                <h6 class=\"mt-0 mb-0 d-inline-block font-weight-bold\">{{avatars[1]}}</h6>\n                <p class=\"mb-0 d-inline-block\">{{avatars[2]}}</p>\n            </div>\n        </div>\n        <hr *ngIf=\"avatars\" class=\"mt-0 mb-2 ml-3 mr-3\">\n        <ng-container *ngFor=\"let model of items;\">\n            <p class=\"model-title mb-1 pt-2 mt-1 pl-4\">{{model.modelTitle | titlecase}}</p>\n            <div class=\"menu-block pr-3 {{group.active?activeMainClass:''}}\" *ngFor=\"let group of model.menuGroups\">\n                <div class=\"menu-main pointer pl-2\" (click)=\"toggleGroup(group)\">\n                    <div class=\"d-table w-100 pb-1 {{group.active?textClass:''}}\">\n                        <div class=\"d-table-cell text-center ts-icon\">\n                            <i [class]=\"group.icon\" aria-hidden=\"true\"></i>\n                        </div>\n                        <div class=\"d-table-cell\">\n                            <span>{{group.groupTitle | titlecase}}</span>\n                        </div>\n                        <div class=\"d-table-cell text-right pr-2\">\n                            <i class=\"fa fa-angle-down\" aria-hidden=\"true\"\n                            [class.icon-up]=\"group.active\" [class.icon-down]=\"!group.active\"></i>\n                        </div>\n                    </div>\n                </div>\n                <div class=\"menu-child-block pr-3\" [class.child-open]=\"group.active\" [class.child-close]=\"!group.active\">\n                    <div class=\"menu-child-item pl-2\" *ngFor=\"let item of group.menuItems;index as i\">\n                        <div class=\"d-table w-100 pointer {{item.active?textClass:''}}\" (click)=\"toggleMenu(group,i)\">\n                            <div class=\"d-table-cell text-center ts-icon\">\n                                <!--<img src=\"https://png.icons8.com/small/50/000000/sphere.png\" height=\"14\">-->\n                            </div>\n                            <div class=\"d-table-cell\">\n                                <span>{{item.title}}</span>\n                            </div>\n                        </div>\n                    </div>\n                </div>\n            </div>\n        </ng-container>\n        <div class=\"menu-temp-bar\"></div>\n    </div>",
                    styles: [
                        "\n        .ts-icon{\n            width:30px;\n        }\n        .icon-up {\n            animation: icon-up 0.5s ease-out forwards;\n        }\n        .icon-down {\n            animation: icon-down 0.5s ease-out forwards;\n        }\n        .model-title{\n            font-size: 15px;\n            opacity: 0.8;\n        }\n        .menu-block {\n            overflow-y: hidden;\n            font-size: 14px;\n            -moz-user-select: none;\n            -webkit-user-select: none;\n            -ms-user-select: none;\n            -khtml-user-select: none;\n            user-select: none;\n            border-left-width:3px;\n            border-left-style:solid;\n            border-left-color:transparent;\n        }\n        .menu-main{\n            line-height:35px;\n        }\n        .menu-child-block{\n            line-height:35px;\n        }\n        .child-close {\n            max-height: 0px;\n            opacity: 0.5;\n            transform-origin: 50% 0%;\n            transition: all 0.5s linear;\n        }\n        .child-open {\n            max-height: 400px;\n            opacity: 1;\n            transform-origin: 50% 0%;\n            transition: all 1.5s linear;\n        }\n        @keyframes icon-up {\n            0% {\n                transform: rotate(0deg);\n            }\n            100% {\n                transform: rotate(180deg);\n            }\n        }\n        @keyframes icon-down {\n            0% {\n                transform: rotate(180deg);\n            }\n            100% {\n                transform: rotate(0deg);\n            }\n        }\n        .menu-temp-bar{\n            height:60px;\n        }\n        .bg-primary-fill{\n            background-color:#007bff11;\n        }\n        .bg-secondary-fill{\n            background-color:#6c757d11;\n        }\n        .bg-success-fill{\n            background-color:#28a74511;\n        }\n        .bg-danger-fill{\n            background-color:#dc354511;\n        }\n        .bg-warning-fill{\n            background-color:#ffc10711;\n        }\n        .bg-dark-fill{\n            background-color:#343a4011;\n        }\n        .bg-info-fill{\n            background-color:#17a2b811;\n        }\n        ",
                    ]
                },] },
    ];
    /** @nocollapse */
    MenuComponent.ctorParameters = function () { return []; };
    MenuComponent.propDecorators = {
        "items": [{ type: core_1.Input },],
        "avatars": [{ type: core_1.Input },],
        "menuActiveChange": [{ type: core_1.Output },],
    };
    return MenuComponent;
}(attr_class_1.DomAttr));
exports.MenuComponent = MenuComponent;
//# sourceMappingURL=menu.component.js.map